<?xml version="1.0" encoding="UTF-8"?>
<project  xmlns:if="ant:if"
 xmlns:unless="ant:unless"
 basedir="." name="unpaywall2rdf" default="unpaywallImport" >
    <property file="unpaywall.properties"/>

    <property name="unpaywall.dump.uri" value="https://s3-us-west-2.amazonaws.com/unpaywall-data-updates/full_dois_2018-03-29T113154.jsonl.gz"/>    
    <property name="unpaywall.output" value="E:/out2.n3"/>
    <available file="${unpaywall.output}.gz" property="output.present"/>
<target name="unpaywall2n3">    
    <mkdir dir="snapshot"/>
    <get skipexisting="true" src="${unpaywall.dump.uri}" dest="snapshot/"/>
    <fileset dir="snapshot" id="upwdump">
         <include name="*.gz"/>
    </fileset>
    <pathconvert refid="upwdump" property="upwgzip"/>
    <echo message="unpacking ${upwgzip} to snapshot/"/>
    <gunzip src="${upwgzip}" dest="snapshot" unless:set="output.present"/>
    <fileset id="upwjsonl" dir="snapshot">
        <include name="*.jsonl"/>
    </fileset>
    <pathconvert refid="upwjsonl" property="unpaywall.input"/> 
    <get skipexisting="true" dest="lib/" src="http://central.maven.org/maven2/net/sf/saxon/Saxon-HE/9.8.0-12/Saxon-HE-9.8.0-12.jar"/>
    <echo message="transforming ${unpaywall.input} to ${unpaywall.output}"/>
    <available file="${unpaywall.output}.gz" property="output.present"/>
    <java classname="net.sf.saxon.Transform"  failonerror="true" output="upw.log" unless:set="output.present">
        <classpath path="lib/Saxon-HE-9.8.0-12.jar"/>
        <classpath path="lib/ubbsef-1.0-SNAPSHOT.jar"/>
        <arg line="-s:dummy.xml -xsl:xsl/unpaywall2n3.xsl -o:${unpaywall.output} -init:no.uib.saxon.ef.SimmetricsInitializer oadoi-path=${unpaywall.input}"/>
    </java>
    <delete file="${unpaywall.input}"/>
    <echo message="deleting unpaywall input"/> 
    <echo message="packaging ${unpaywall.output} to ${unpaywall.output}.gz"/>
    <gzip src="${unpaywall.output}" destfile="${unpaywall.output}.gz"/>
    <delete file="${unpaywall.output}"/>    
    <echo message="deleting ${unpaywall.output}"/>
</target>
    
<target name="unpaywallImport" depends="unpaywall2n3">
    <replace file="unpaywall-config.ttl" token="REPO_ID" value="${unpaywall.repo.name}"/>
    <echo message="loading ${unpaywall.output}.gz, ${unpaywall.ontology}  to ${unpaywall.repo.name}"/>
    <exec executable="../bin/preload" failonerror="true">
        <arg value="-f"/>
        <arg value="-c"/>
	<arg value="unpaywall-config.ttl"/>
        <arg value="${unpaywall.output}.gz"/>
        <arg value="ontology/unpaywall.owl"/>
        <arg value="snapshot/cristin.nq"/>
    </exec>
</target>
</project>
